import Link from "next/link";
import Head from "next/head";
import { Button, Typography } from "@material-ui/core";
import { makeStyles } from "@material-ui/core/styles";
import Paper from "@material-ui/core/Paper";
import ChevronRightIcon from "@material-ui/icons/ChevronRight";
import AuthProvider from "../../../../components/AuthProvider";
import Layout from "../../../../components/admin/Layout";
import EditFormByStepper from "../../../../components/admin/products/edit/EditFormByStepper";
import xantiayadakAPI from "../../../../apis/xantiayadak";

const useStyles = makeStyles((theme) => ({
  root: {
    width: "100%",
    padding: "20px",
  },
  addBtn: {
    "& .MuiButton-startIcon": {
      marginLeft: "10px",
    },
  },
  title: {
    textAlign: "center",
    margin: "20px",
    fontSize: "32px",
    textShadow: `1px 1px 5px ${theme.palette.primary.main}`,
  },
}));

export default function EditProduct({ product }) {
  const classes = useStyles();

  return (
    <>
      <Head>
        <title>ویرایش محصول {product.name} | پنل ادمین زانتیا یدک</title>
        <meta name="description" content="Generated by create next app" />
        <link rel="icon" href="/xantia-logo-svg-vector.svg" />
      </Head>
      <Layout>
        <AuthProvider>
          <Paper className={classes.root}>
            <Link href="/admin/products/products-list">
              <a>
                <Button
                  className={classes.addBtn}
                  startIcon={<ChevronRightIcon />}
                >
                  بازگشت به لیست محصولات
                </Button>
              </a>
            </Link>
            <Typography varinat="h1" className={classes.title}>
              ویرایش محصول
            </Typography>
            <EditFormByStepper product={product} />
          </Paper>
        </AuthProvider>
      </Layout>
    </>
  );
}

export const getStaticPaths = async () => {
  const products = await xantiayadakAPI.get("/products");

  return {
    fallback: "blocking",
    paths: products.data.data.map((product) => ({
      params: { productId: product._id },
    })),
  };
};

export const getStaticProps = async (context) => {
  const productId = context.params.productId;

  const product = await xantiayadakAPI.get(`/products/${productId}`);

  return {
    props: {
      product: product.data.data,
    },
    revalidate: 1 * 5,
  };
};
